#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Aug  8 12:05:33 2017

@author: IsabellTrinh
"""

from abc import ABC, abstractmethod

class FlaskData(ABC):
    
    @abstractmethod
    def makeChain(self, length, startpos, props, lts):
        '''
        Generates a chain of a given length, with units with certain linktypes and properties in the lattice.
        '''
        pass
    
    @abstractmethod
    def _findPath(self, pos, vpos, length):
        '''
        Finds a path for a chain of given length from the given startposition.
        '''
        pass
    
    @abstractmethod
    def canMove(self, ident):
        '''
        Returns a boolean, 'true' if there is an open lattice spot the unit can move to, 'false' if there is none.
        '''
        pass
    
    @abstractmethod
    def translateChain(self, chainIdent, shift):
        '''
        Moves Chain by a certain number of lattice rows/columns.
        '''
        pass
    
    
    